; Recommended for performance and compatibility with future AutoHotkey releases :
#NoEnv
; une seule instance  la fois (= "ignorer" les autres lancements)
#SingleInstance ignore
; Recommended for new scripts due to its superior speed and reliability :
SendMode Input

; coordonnes relatives  de l'écran
CoordMode, Mouse, Screen
CoordMode, ToolTip, Screen
CoordMode, Pixel, Screen
CoordMode, Mouse, Screen
CoordMode, Caret, Screen
CoordMode, Menu, Screen

SetTitleMatchMode, 2 ; doit contenir au moins

LumiereSelectionnee := False
LumiereAEteSelectionnee := False

DebutX := 0
DebutY := 0
PositionZ := 0
PremierAppelPlaceHomeDecale := True

;------------------------------------------------------------------------
ActiverFenetre(AFenetre)
{
  WinWait, %AFenetre%
  IfWinNotActive, %AFenetre%
  {
    WinActivate, %AFenetre%
    WinWaitActive, %AFenetre%
  }
}
;-----------------------------------
; sélections
; ------------
TMPieceSelectionnerSleep()
{
  Sleep, 100
}
TMPieceSelectionnerRevenirEnArriere()
{
    ; sélection pièce : revenir en arrière
    Send, {vkFFsc029}
    TMPieceSelectionnerSleep()
}
TMPieceSelectionnerTouche1()
{
    ; touches sélection item sous trackmania
    ; sélection pièce : touche 1
    Send, {vk31sc002}
    TMPieceSelectionnerSleep()
}
TMPieceSelectionnerTouche2()
{
    ; sélection pièce : touche 2
    Send, {vk32sc003}
    TMPieceSelectionnerSleep()
}
TMPieceSelectionnerTouche3()
{
    ; sélection pièce : touche 3
    Send, {vk33sc004}
    TMPieceSelectionnerSleep()
}
TMPieceSelectionnerTouche4()
{
    ; sélection pièce : touche 4
    Send, {vk34sc005}
    TMPieceSelectionnerSleep()
}
TMPieceSelectionnerTouche5()
{
    ; sélection pièce : touche 5
    Send, {vk35sc006}
    TMPieceSelectionnerSleep()
}
TMPieceSelectionnerTouche6()
{
    ; sélection pièce : touche 6
    Send, {vk36sc007}
    TMPieceSelectionnerSleep()
}
TMPieceSelectionnerTouche7()
{
    ; sélection pièce : touche 7
    Send, {vk37sc008}
    TMPieceSelectionnerSleep()
}
TMPieceSelectionnerTouche8()
{
    ; sélection pièce : touche 8
    Send, {vk38sc009}
    TMPieceSelectionnerSleep()
}
TMPieceSelectionnerTouche9()
{
    ; sélection pièce : touche 9
    Send, {vk39sc00A}
    TMPieceSelectionnerSleep()
}

;-----------------------------------
TMSautSelectionner()
{
    global LumiereSelectionnee
    LumiereSelectionnee := False
    TMSelection( "622" )
}

TMSautComplementSelectionner()
{
    global LumiereSelectionnee
    LumiereSelectionnee := False
    TMSelection( "624" )
}

TMBlocBasiqueSelectionner()
{
    global LumiereSelectionnee
    LumiereSelectionnee := False
    TMSelection( "621" )
}

TMLumiereSelectionner()
{
    global LumiereSelectionnee, LumiereAEteSelectionnee
    Sleep, 100
    LumiereSelectionnee := True
    LumiereAEteSelectionnee := True
    TMSelection( "867" )
    Sleep, 400
}

TMRouteSelectionner()
{
    global LumiereSelectionnee
    LumiereSelectionnee := False
    TMSelection( "211" )
}

TMSautRouteSelectionner()
{
    global LumiereSelectionnee
    LumiereSelectionnee := False
    TMSelection( "312" )
}

;-----------------------------------
; tourner
; ------------
TMPieceTourner()
{
    ; tourner pièce = CTRL droit clavier
    Send, {vkA3sc11D}
    Sleep, 50
}
;-----------------------------------
; déplacements
; ------------
TMCurseurDeplacerHautGauche()
{
    ; se mettre en haut à gauche
    Send, {AltDown}
    Sleep, 50
    Send, {AltUp}
    Sleep, 50
    SendInput, {Left 40}
    SendInput, {Up 40}
    Sleep, 100
    SendInput, {Left 40}
    SendInput, {Up 40}
    Sleep, 100
}
TMCurseurDeplacerSleep()
{
    global PositionZ
    global LumiereSelectionnee
    global LumiereAEteSelectionnee
    
    if (LumiereSelectionnee == True)
      Sleep, 80
    if (LumiereAEteSelectionnee == True)
      Sleep, 40

    ; (!) TEST pour labys énormes, à virer
    ; et juste mettre "Sleep, 1" en temps normal !
    ;
    ; faire une pause de plus en plus
    ; grande en fonction du niveau :
    ; étage : 1, pause = 11
    ; étage : 2, pause = 21
    ; étage : 3, pause = 31
    ; étage : 4, pause = 41
    ; étage : 5, pause = 51
    ; étage : 6, pause = 61
    ; étage : 7, pause = 71
    ; étage : 8, pause = 81
    ; étage : 9, pause = 91
    ; étage : 10, pause = 101
    ; étage : 11, pause = 111
    ; étage : 12, pause = 121
    ; étage : 13, pause = 131
    ; étage : 14, pause = 141
    ; étage : 15, pause = 151
    ; étage : 16, pause = 161
    ; étage : 17, pause = 171
    ; étage : 18, pause = 181
    ; étage : 19, pause = 191
    ; étage : 20, pause = 201
    ; étage : 21, pause = 211
    ; étage : 22, pause = 221
    ; étage : 23, pause = 231
    ; étage : 24, pause = 241
    ; étage : 25, pause = 251
    ; étage : 26, pause = 261
    ; étage : 27, pause = 271
    ; étage : 28, pause = 281
    ; étage : 29, pause = 291

    Pause := 1 + ( ( PositionZ - 7 ) * 10)
    if (Pause < 0)
        Pause := 1

    ; c'est ptet trop (voir tableau au dessus),
    ; donc je limite à 100 :
    if (Pause > 200)
        Pause := 200
        
    Pause := 1
    Sleep, %Pause%
}

TMCurseurDeplacerRight()
{
    SendInput, {Right}
    TMCurseurDeplacerSleep()
}
TMCurseurDeplacerLeft()
{
    SendInput, {Left}
    TMCurseurDeplacerSleep()
}
TMCurseurDeplacerUp()
{
    SendInput, {Up}
    TMCurseurDeplacerSleep()
}
TMCurseurDeplacerDown()
{
    SendInput, {Down}
    TMCurseurDeplacerSleep()
}
TMCurseurDeplacerPgUp( ARapide = False )
{
    global PositionZ
    PositionZ++
    
    ; déplacement pièce : touche PgUp
    Send, {vk21sc149}
    if (ARapide == False) {
        Pause := 200 + ( ( PositionZ - 7 ) * 10)
        if (Pause < 0)
            Pause := 1
        Sleep, %Pause%
    }
    else {
        Sleep, 100
;        Loop, 4 {
;            TMCurseurDeplacerSleep()
;        }
    }
}
TMCurseurDeplacerPgDown( ARapide = False )
{
    global PositionZ
    PositionZ--
    
    ; déplacement pièce : touche PgDown
    Send, {vk22sc151}
    if (ARapide == False) {
        Pause := 200 + ( ( PositionZ - 7 ) * 10)
        if (Pause < 0)
            Pause := 1
        Sleep, %Pause%
    }
    else {
        Sleep, 100
;        Loop, 4 {
;            TMCurseurDeplacerSleep()
;        }
    }
}
;-----------------------------------
TMPiecePoser()
{
    global LumiereSelectionnee
    global LumiereAEteSelectionnee
    SendInput, {SPACE}

    if (LumiereSelectionnee == True)
      Sleep, 80

    if (LumiereAEteSelectionnee == True)
      Sleep, 80

    Sleep, 50
}
;-----------------------------------
TMPieceSupprimer()
{
    SendInput, {DEL}
    Sleep, 50
}

-----------------------------------
TMExecute( ASTR )
{
  L := StrLen( ASTR )
  Loop, %L% {
      Ordre := SubStr(ASTR, A_Index, 1)
      if (Ordre == "H") {
          ; 'H' = home
          TMCurseurDeplacerHautGauche()
      }
      else if (Ordre == "U") {
          ; 'U' = Up
          TMCurseurDeplacerUp()
      }
      else if (Ordre == "D") {
          ; 'D' = Down
          TMCurseurDeplacerDown()
      }
      else if (Ordre == "L") {
          ; 'L' = Left
          TMCurseurDeplacerLeft()
      }
      else if (Ordre == "R") {
          ; 'R' = Right
          TMCurseurDeplacerRight()
      }
      else if (Ordre == "T") {
          ; 'T' = Tourner = Rotate
          TMPieceTourner()
      }
      else if (Ordre == "+") {
          ; '+' = Monter un niveau = PgUp
          TMCurseurDeplacerPgUp()
      }
      else if (Ordre == "-") {
          ; '-' = Descendre un niveau = PgDown
          TMCurseurDeplacerPgDown()
      }
      else if (Ordre == "*") {
          ; '*' = Poser la pièce
          TMPiecePoser()
      }
      else if (Ordre == "!") {
          ; '!' = Supprimer la pièce
          TMPieceSupprimer()
      }
      else if (Ordre == "S") {
          Send, {Space down}
          ;TMCurseurDeplacerSleep()
      }
      else if (Ordre == "s") {
          Send, {Space up}
          TMCurseurDeplacerSleep()
      }
      else {
          MsgBox, Ordre Inconnu : <%Ordre%>, on quitte
          Exit,
      }
  }
}
TMSelection( ASTR )
{
    Loop, 5 {
        TMPieceSelectionnerRevenirEnArriere()
    }

    L := StrLen( ASTR )
    Loop, %L% {
        Ordre := SubStr(ASTR, A_Index, 1)
        if (Ordre == "1") {
            TMPieceSelectionnerTouche1()
        }
        else if (Ordre == "2") {
            TMPieceSelectionnerTouche2()
        }
        else if (Ordre == "3") {
            TMPieceSelectionnerTouche3()
        }
        else if (Ordre == "4") {
            TMPieceSelectionnerTouche4()
        }
        else if (Ordre == "5") {
            TMPieceSelectionnerTouche5()
        }
        else if (Ordre == "6") {
            TMPieceSelectionnerTouche6()
        }
        else if (Ordre == "7") {
            TMPieceSelectionnerTouche7()
        }
        else if (Ordre == "8") {
            TMPieceSelectionnerTouche8()
        }
        else if (Ordre == "9") {
            TMPieceSelectionnerTouche9()
        }
        else {
            MsgBox, Ordre Inconnu : <%Ordre%>, on quitte
            Exit,
        }
    }
}
;-----------------------------------
TMDepartSelectionner()
{
    TMSelection( "222" )
}
TMDepartPoser()
{
    TMExecute( "HH+RTT*TT" )
}
TMArriveeSelectionner()
{
    TMSelection( "223" )
}
TMArriveePoser( AX, AY, AZ )
{
    TMExecute( "H" )
    L := AX - 1
    Loop, %L% {
        TMExecute( "RR" )
    }
    TMExecute( "R" )

    L := AY
    Loop, %L% {
        TMExecute( "DD" )
    }

    ; se plaquer au sol :
    L := AZ * 2
    Loop, %L% {
        TMCurseurDeplacerPgDown( True )
    }
    ; remonter niveau :
    L := ( (AZ - 1) * 2) - 1
    Loop, %L% {
        TMExecute( "+" )
    }

    ; poser + revenir position de départ :
    TMExecute( "TT+!+!--!*TT" )
    L := ( (AZ - 1) * 2) - 1
    Loop, %L% {
        TMExecute( "-" )
    }
}


TMPlaceHomeDecale( AX, AY, AZ ) {
    global PositionZ
    global DebutX
    global DebutY
    global PremierAppelPlaceHomeDecale

    ; revenir tout en haut à gauche
    TMExecute( "H" )
    if (PremierAppelPlaceHomeDecale == True) {
        PremierAppelPlaceHomeDecale := False
    }
    else {
        ; se coller au sol :
        Loop, 32 {
            TMCurseurDeplacerPgDown( True )
        }
        PositionZ := 0
    }

    Loop, %DebutX% {
        TMExecute( "R" )
    }
    Loop, %DebutY% {
        TMExecute( "D" )
    }

    DebutX += AX
    DebutX += 3
    if ( ( DebutX + AX) > 31) {
        DebutX := 0
        DebutY += AY
        DebutY += 3
    }

}
